/* credit to @ali#9824 on discord for this code! its reusable as long as you credit too */

addHook("PlayerThink", function(player)
    if (player.mo and player.mo.valid) and player.mo.skin == "phoenix" then
        if player.isdashing == nil then player.isdashing = false end
        if player.cmd.buttons & BT_CUSTOM1 then
            player.isdashing = true
        else
            player.isdashing = false
        end
        if player.isdashing then
            player.normalspeed = 52*FRACUNIT
            if P_IsObjectOnGround(player.mo) then
                if player.speed >= 20*FRACUNIT then
                    player.mo.state = S_PLAY_DASH
                elseif player.speed < 20*FRACUNIT and player.speed > 0 then
                    player.mo.state = S_PLAY_WALK
                else
                    player.mo.state = S_PLAY_STND
                end
            end
        else
            player.normalspeed = skins[player.mo.skin].normalspeed
        end
    end
end)

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid) and player.mo.skin == "phoenix" then
		if player.mo.eflags & MFE_UNDERWATER then
			player.charability = CA_SWIM
		else
			player.charability = CA_DOUBLEJUMP
		end
	end
end)


addHook("PlayerThink", function(player)
	if player.mo.skin ~= "phoenix" then
		return
	end

	if (player.cmd.buttons & BT_USE) and P_IsObjectOnGround(player.mo) and player.speed == 0 then
		player.height = 30*FRACUNIT
		player.mo.state = S_PLAY_GLIDE_LANDING
	else
		player.height = 48*FRACUNIT
	end
end)

local function functionname(player)
    if player.mo.skin ~= "phoenix" then
        return
    end
        
    if P_IsObjectOnGround(player.mo) and player.speed > 5 then
        player.pflags = $|PF_SPINNING
        player.mo.state = S_PLAY_ROLL  
		S_StartSound(player.mo, sfx_spin)
    end
    return true
end

addHook("SpinSpecial", functionname)

addHook("AbilitySpecial", function(player)
    if player.mo.skin == "phoenix" then
        if player.abilityused < 2 and player.dualdelay == 0 then
            player.abilityused = $ + 1
            player.dualdelay = $ + TICRATE/2
            if player.currentability == 0 then -- Let's internally call 0 a Thok.
                P_SetObjectMomZ(player.mo, 0*FRACUNIT)
                P_Thrust(player.mo, player.mo.angle, 20*FRACUNIT)
                S_StartSound(player.mo, sfx_zoom)
                local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
                thok.color = player.mo.color
                player.pflags = $1|PF_SPINNING
                player.currentability = 1 -- Change for the next ability to be Double Jump.
            else -- If it's not 0, it's Double Jump.
                P_DoJump(player)
                player.currentability = 0 -- Back to the Thok!
            end
        end
    end
end)

addHook("PlayerThink", function(player)
    if player.mo.skin == "phoenix" then
        if player.dualdelay == nil then player.dualdelay = 0
        elseif player.dualdelay > 0 then player.dualdelay = $ - 1 end
        if P_IsObjectOnGround(player.mo) then player.abilityused = 0 end
    end
end)

addHook("JumpSpinSpecial", function(player)
    if player.mo.skin == "phoenix" then
        if player.abilityused < 2 and player.dualdelay == 0 then
            player.abilityused = $ + 1
            player.dualdelay = $ + TICRATE/2
            if player.currentability == 1 then -- Let's internally call 0 a Thok.
                P_SetObjectMomZ(player.mo, 0*FRACUNIT)
                P_Thrust(player.mo, player.mo.angle, 20*FRACUNIT)
                S_StartSound(player.mo, sfx_zoom)
                local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
                thok.color = player.mo.color
                player.pflags = $1|PF_SPINNING
                player.currentability = 0 -- Change for the next ability to be Double Jump.
            else -- If it's not 0, it's Double Jump.
                P_DoJump(player)
                player.currentability = 1 -- Back to the Thok!
            end
        end
    end
end)